<?php

namespace Runtime\Factory;

use ClassNotFoundException;
use Pecee\SimpleRouter\SimpleRouter;
use Runtime\Exceptions\ExceptionHandler;

class BootstrapFactory {

    public function handle()
    {
        SimpleRouter::setDefaultNamespace('\App\Http\Controllers');

        require_once('../routes/web.php ');

        try {
            SimpleRouter::start();
        }
        catch (\Exception $e) {
            ExceptionHandler::make($e);
        }
    }

    /**
     * @param $abstract
     * @return mixed
     */
    public function make($abstract)
    {
        return $this->resolve($abstract);
    }

    /**
     * @param $abstract
     * @return mixed|null
     */
    private function resolve($abstract) {
        if(class_exists($abstract)) {
            return new $abstract;
        }

        ExceptionHandler::make(ClassNotFoundException::class);
        return null;
    }

}